package com.gree.mall.manager.config.aop;

import org.aspectj.lang.ProceedingJoinPoint;
import org.aspectj.lang.annotation.Around;
import org.aspectj.lang.annotation.Aspect;
import org.springframework.stereotype.Component;

@Aspect
@Component
public class MemoryMonitorAspect {

    @Around("execution(* com.gree.mall.manager.controller..*(..))") // 替换为您的控制器包路径
    public Object monitorMemoryUsage(ProceedingJoinPoint joinPoint) throws Throwable {
        Runtime runtime = Runtime.getRuntime();
        long beforeMemory = runtime.totalMemory() - runtime.freeMemory();

        // 执行方法
        Object result = joinPoint.proceed();

        long afterMemory = runtime.totalMemory() - runtime.freeMemory();
        long memoryUsed = afterMemory - beforeMemory;

        System.out.println("方法: " + joinPoint.getSignature() + ", 使用内存: " + memoryUsed + " bytes");

        return result;
    }
}
